<?php
namespace Modules\Main\Models\Scopes;
 
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Scope;
 
class CityScope implements Scope
{
    /**
     * Apply the scope to a given Eloquent query builder.
     */
    public function apply(Builder $builder, Model $model): void
    {
            //dd(GetAvailableCities());
            if ($cities = GetAvailableCities()) { //получаю доступные пользователю города
                $citiesIds = $cities->pluck('id')->toArray();
                $builder->whereHas('cities', fn($q) => $q->whereIn('cities.id', $citiesIds));
                $builder->OrDoesntHave('cities');
            } else {
                $builder->where('id', 0);//не знаю, как сделать, чтобы выбор был гарантированно пустой
            }
    }
}
?>